
%\definecolor{light-gray}{gray}{0.92}  
\newcommand{\lightgray}[1]{\textcolor{lightgray}{{#1}}}
%\definecolor{dark-gray}{gray}{0.20}  
\newcommand{\darkGray}[1]{\textcolor{dark-gray}{{#1}}}
\newcommand{\red}[1]{\textcolor{red}{{#1}}}
\newcommand{\gray}[1]{\textcolor{gray}{{#1}}}
\newcommand{\blue}[1]{\textcolor{blue}{{#1}}}


\newcommand{\kleenestar}{\relax\ifmmode {^*}\else{$\,^{\star}$}\fi}
\newcommand{\kleeneplus}{\relax\ifmmode {^+}\else{$\,^+$}\fi}
\newcommand{\abit}{\hspace{1em}}
\newcommand{\aweebit}{\hspace{.35em}}
\newcommand{\atinyweebit}{\hspace{.15em}}
\newcommand{\nudge}[1]{\atinyweebit{#1}\atinyweebit}
\newcommand{\elbow}[1]{\aweebit{#1}\aweebit}
\newcommand{\twice}[1]{{#1}{#1}}
\newcommand{\thrice}[1]{{#1}{#1}{#1}}
\newcommand{\threebits}{\thrice\abit}
\newcommand{\twobits}{\twice\abit}
\newcommand{\bits}[1]{\hspace{#1em}}



\newcommand{\sub}[1]{\relax\ifmmode{_{#1}}\else{{$\!\;_{{#1}$}}}\fi}

\newcommand{\union}{\nudge\vbar}

%%%%   Commands to wrap different kind of \tt parens around an argument
\newcommand{\pairwrap}[1]{{\ifmmode{{\langle{}{#1}\rangle{}}}\else{$\langle${{#1}}$\rangle$}\fi}}
\newcommand{\setwrap}[1]{{\ifmmode{{\mathtt{\{}}{#1}\,{\mathtt{\}}}}\else{{\tt{\{}}{#1}\aweebit{\tt{\}}}}\fi}}
\newcommand{\parenwrap}[1]{{\ifmmode{\text{\tt{(}}{#1}\text{\tt{)}}}\else{\tt{(}}{#1}{\tt{)}}\fi}}
\newcommand{\barwrap}[1]{{\ifmmode{\text{\tt{|}}{#1}\text{\tt{|}}}\else{\tt{|}}{#1}{\tt{|}}\fi}}
\newcommand{\squarewrap}[1]{{\ifmmode{\mathtt{[}{{#1}}\atinyweebit{\mathtt{]}}}\else{\tt{[}{{#1}}\atinyweebit{\tt{]}}}\fi}}
\newcommand{\singlequotewrap}[1]{{\ifmmode{\text{\textquotesingle{}{{#1}}\atinyweebit\textquotesingle}}\else{\textquotesingle{}{{#1}}\atinyweebit\textquotesingle}\fi}}
\newcommand{\sigwrap}[1]{{\ifmmode{\text{\tt{(|}}{#1}\text{\tt{|)}}}\else{\tt{(|}}{#1}{\tt{|)}}\fi}}

\newcommand{\singlequotes}[1]{\textquotesingle{}{#1}\textquotesingle{}}
\newcommand{\doublequotewrap}[1]{{\rm{``{#1}''}}}




\newcommand{\textmath}[2]{\newcommand{#1}{{{\relax\ifmmode{#2}\else{${#2}$}\fi}}}}

\newcommand{\mkmathit}[2]{\newcommand{#1}{{\relax\ifmmode{\mathit{#2}}\else{{\it{#2}}}\fi\relax}}}
\newcommand{\mktype}[2]{\mkmathit{#1}{#2}}

\newcommand{\mkkeyword}[2]{\newcommand{{#1}}{{\ifmmode{{\mathtt{#2}}}\else{\tt{#2}}\fi}}}
\newcommand{\newsyntax}[2]{\newcommand{#1}{{\ifmmode{\mathit{#2}}\else{\it{#2}}\fi}\relax}}

\textmath{\just}{{\mathit{Just}}}
\textmath{\nothing}{{\mathit{Nothing}}}


\newcommand{\ses}[1]{
{{{\relax\ifmmode{{{\mathcal{M}}\atinyweebit{#1}}}\else{${\mathcal{M}}\atinyweebit{#1}$}\fi}}}}

\newcommand{\smallsection}[1]{\paragraph{\bf\em{{#1}}}\index{#1}}
\newcommand{\flength}[1]{{\relax\ifmmode{\vbar{}{#1}\vbar}\else{$\vbar{}{#1}\vbar{}$}\fi}}
\textmath{\boolReln}{{{\cal{R}}_{\mathbb{B}}}}
%\textmath{}{{\cal{B}}_{op}}
\newcommand{\boolop}{\boolreln}

\mkkeyword{\kwdeposits}{deposits}
\mkkeyword{\kwinto}{into}
\mkkeyword{\kwfun}{fun}
\mkkeyword{\kwfrom}{{from}}
\mkkeyword{\kwstart}{{start}}
\mkkeyword{\kwend}{{end}}
\mkkeyword{\kwchoice}{{choice}}
\textmath{\fchoice}{{\cal{C}}h}
\textmath{\nicev}{{\text{\bf\em{v}}}}
\textmath{\identifier}{{\cal{I}}}
%\textmath{\dotid}{{\cal{X}}}
\newsyntax{\dotid}{X}
\mkkeyword{\kwdo}{do}
\mktype{\tyDotId}{dot.Id}
%\newsyntax{\identifier}{I}
%\textmath{\choiceId}{\identifier_{C}}
\newsyntax{\choiceId}{Ch}
%\textmath{\accountId}{{\identifier_{A}}}
\textmath{\accountId}{{{\cal{A}}cc}}
\newsyntax{\acc}{}

\textmath{\internalAccount}{{\mathtt{@}}\party}
\textmath{\externalAccount}{{\mathtt{!}}\party}



\textmath{\fileId}{\identifier_{F}}

\mkkeyword{\kwas}{as}
\mkkeyword{\kwnotify}{notify}
\mkkeyword{\kwvar}{var}
\mkkeyword{\kwavailablemoney}{{\$}}
\mkkeyword{\semicolon}{{;\atinyweebit}}
\mkkeyword{\kwopen}{open}
\mkkeyword{\kwimport}{import}
\mkkeyword{\kwassert}{assert}
\mkkeyword{\kwwithin}{within}
\mkkeyword{\kwchooses}{chooses}
\mkkeyword{\kwnot}{not}
\mkkeyword{\kwbool}{bool}
\mkkeyword{\kwint}{int}
\mkkeyword{\kwtoken}{token}
%\newcommand{\twist}[1]{\stackrel{\hspace{.25em}{\circlearrowleft\hspace{-.9em}\longrightarrow}}{#1}}
%\newcommand{\twist}[1]{\stackrel{\infty}{#1}}

\newcommand{\refp}[1]{\ref{#1}~ on pg.~\pageref{#1}}

\newcommand{\twist}[1]{\gamma\atinyweebit{}{#1}}%{\stackrel{\stackrel{\,}{\leftarrow}}{#1}}
\newcommand{\longtwist}[1]{\twist{#1}}%{\stackrel{\stackrel{\,}{\longleftarrow}}{#1}}

\newcommand{\mapswap}[1]{{\relax\ifmmode{\twist{#1}}\else{{$\twist{#1}$}}\fi}}

\newcommand{\longmapswap}[1]{{\relax\ifmmode{\longtwist{#1}}\else{{$\twist{#1}$}} \fi}}

% note - the following two have been switched from right to left arrows because we never (?) turn a conext into a parameter list.
\newcommand{\untwist}[1]{\twist{{#1}}}%{\stackrel{\stackrel{\,}{\leftarrow}}{#1}}
\newcommand{\longuntwist}[1]{\twist{{#1}}}%{\stackrel{\stackrel{\,}{\longleftarrow}}{#1}}

\newcommand{\mapunswap}[1]{{\relax\ifmmode{\untwist{#1}} \else {{ $\untwist{#1}$ }} \fi}}
\newcommand{\longmapunswap}[1]{{\relax\ifmmode{\longuntwist{#1}} \else {{ $\untwist{#1}$ }} \fi}}
\textmath{\btau}{\tau\!\!\!\tau}
\textmath{\arrow}{{\text{\tt{->}}}}
\textmath{\unit}{{\text{\tt{()}}}}
\textmath{\fst}{\mathit{fst}}
\textmath{\snd}{\mathit{snd}}
\textmath{\dom}{{dom}}
\textmath{\rng}{{rng}}
\textmath{\cOne}{\contract_1}
\textmath{\cTwo}{\contract_2}
\textmath{\cThree}{\contract_3}
%\textmath{\fcase}{{\mathscr{C}}} 
%\textmath{\fcase}{{\mathcal{C}}a} 
\textmath{\fcase}{{\mathcal{C}}\!{\mathit{a}}} 
\textmath{\fGuard}{{\mathcal{G}}}
\textmath{\module}{{M}}
\newsyntax{\contract}{C}

\mkkeyword{\kwstatement}{statement}

\mkkeyword{\kwcontract}{contract}
\mktype{\tycontract}{contract}
\mktype{\tyaccountId}{account}
\mktype{\tyChoiceName}{choiceName}
\mktype{\tychoice}{choice}
\mktype{\tybound}{bound}
\mktype{\tymodule}{module}
\mktype{\tycontext}{context}
\mktype{\tyfinfun}{finFun}
%\mktype{\typayee}{payee}
\mktype{\tyaccount}{account}
%\mktype{\typayee}{payee}

\newsyntax{\statement}{S}

\mkkeyword{\kwwhen}{{when}}
\mkkeyword{\kwif}{{if}}
\mkkeyword{\kwthen}{{then}}
\mkkeyword{\kwelse}{{else}}
\mkkeyword{\kwafter}{{after}}
\mkkeyword{\kwpays}{{pays}}
\mkkeyword{\kwdef}{{def}}
\mkkeyword{\kwparty}{{party}}
\mkkeyword{\kwbound}{{bound}}
\mkkeyword{\kwaction}{{action}}
\mkkeyword{\kwcase}{{case}}

\newsyntax{\party}{{P}}
\newsyntax{\expr}{E}
\newsyntax{\decl}{D}
\newsyntax{\fbool}{Bool}
\newsyntax{\posix}{posix}
\mkkeyword{\kwposix}{posix}
\newsyntax{\posixtime}{{Posix\atinyweebit{}Time}}
%\textmath{\payee}{{Py}}
\newsyntax{\parameter}{Par}
\newcommand{\parameters}{{\tt{(}\parameter\kleenestar\tt{)}}}

\newsyntax{\update}{update}
\newcommand{\meaningOf}[1]{\relax{\ifmmode{[\![{{#1}}]\!]}\else{$[\![{{#1}}]\!]$}\fi}\relax}

\newcommand{\domain}[1]{\relax{\ifmmode{{\cal{D}}({#1})}\else{${\cal{D}}({#1})$}\fi}\relax}

\newcommand{\domainStar}[1]{\relax{\ifmmode{{\cal{D}}^*({#1})}\else{${\cal{D}}^*({#1})$}\fi}\relax}

\newcommand{\mhspace}[1]{{\mbox{\hspace{{#1}em}}}}

\textmath{\choiceName}{{\cal{C}}\hspace{-.1em}n}
\newsyntax{\argument}{Arg}
\newsyntax{\action}{A}
\newsyntax{\token}{T}

\textmath{\bound}{{\cal{B}}}
\newsyntax{\observation}{O}
\newsyntax{\mIdentifier}{$\identifier_M$}
\newsyntax{\hash}{{\text{\tt{hash}}}}

\mkkeyword{\kwmodule}{module}
\mkkeyword{\kwexports}{exports}
\mkkeyword{\kwclose}{close}
%\newcommand{\kwAnd}{{\mathtt{\&}{\&}}}
\mkkeyword{\kwAnd}{\&\&}
\mkkeyword{\kwNot}{{!}}
\mkkeyword{\kwMinus}{{-}}
\mkkeyword{\kwPlus}{{+}}
\mkkeyword{\kwTimes}{{*}}
\mkkeyword{\kwDiv}{{/}}
\mkkeyword{\kwEq}{{==}}
\mkkeyword{\kwNotEq}{{!=}}
\mkkeyword{\kwLT}{{<}}
\mkkeyword{\kwLE}{{<=}}
\mkkeyword{\kwGT}{{>}}
\mkkeyword{\kwGE}{{>=}}
\mkkeyword{\kwGuardChoice}{\text{{\tt{<+>}}}}
\mkkeyword{\kwGuardInterleave}{\text{{\tt{|||}}}}
\mkkeyword{\kwlovelace}{lovelace}
\mkkeyword{\kwtrue}{true}
\mkkeyword{\kwfalse}{false}
\newcommand{\boldBar}{{\rule[-1.25pt]{.08em}{1em}}}
\newcommand{\kwOr}{{\boldBar\hspace{.25em}\boldBar}}
\textmath{\grayrho}{{\lightgray{\rho\,}}}
\textmath{\grayrhoone}{{\lightgray{\rho_1\,}}}
\textmath{\grayrhotwo}{{\lightgray{\rho_2\,}}}
\textmath{\grayrhothree}{{\lightgray{\rho_3\,}}}
\textmath{\pure}{\mathit{pure}}
\textmath{\impure}{\mathit{impure}}

\mkkeyword{\kwcolon}{:}
\mkkeyword{\kwquestionmark}{?}

\mktype{\tyexpr}{expr}
\mktype{\tystatement}{statement}
\mktype{\typosix}{posix}
\newcommand{\typosixexpr}{\typosix}
\mktype{\tyint}{int}
\mktype{\haskInt}{Int}
\newcommand{\tyintexpr}{\tyint\atinyweebit\tyexpr}
\mktype{\tybool}{bool}
\mktype{\haskBool}{Bool}
\newcommand{\tyboolexpr}{\tybool\atinyweebit\tyexpr}
\mktype{\typure}{pure}
\mktype{\typureblack}{{pure}}
\mktype{\tyimpure}{{impure}}
\mktype{\typarty}{party}
\mktype{\haskParty}{Party}
\mktype{\tytoken}{token}
\mktype{\haskToken}{Token}
\mktype{\nicebeta}{{\relax\ifmmode{\text{\rm{\textbeta}}}\else{\rm{\textbeta}}\fi}}
\newcommand{\tyepsilonexpr}{\bigepsilon}
\newcommand{\expressionTypes}{\bigepsilon}
\newcommand{\epsilonexpr}{\bigepsilon}
\mktype{\tyaction}{action}

\mktype{\tydecl}{decl}

\mktype{\tyfcase}{case}
\mktype{\tycase}{case}
\mktype{\tyguard}{guard}
\mktype{\tyloc}{loc}

\textmath{\vexp}{{\tyint\atinyweebit\grayrho}}
\newcommand{\intexpr}{\vexp}
\textmath{\oexp}{{\tybool\atinyweebit\grayrho}}
\textmath{\boolexpr}{\tybool\atinyweebit\grayrho}
\newcommand{\aexpr}{\relax\ifmmode{\alpha}\else{$\alpha$}\fi\expr}
\textmath{\posixexpr}{\posix\atinyweebit\grayrho}
\newcommand{\arguments}{\parenwrap{\argument\kleenestar}}
\textmath{\exprI}{\expr}
\textmath{\exprP}{\expr}
\textmath{\exprPI}{\expr}
\textmath{\exprIP}{\expr}
\textmath{\mathtau}{\tau}
\textmath{\bigepsilon}{\large{\varepsilon}}

\textmath{\fancyP}{{\cal{P}}}
\textmath{\scriptyP}{{\mathscr{P}}}

\textmath{\fancyA}{{\mathscr{A}}}

\newcommand{\purebool}{\tybool\atinyweebit\gray\typure}
\newcommand{\impurebool}{\tybool\atinyweebit\gray\tyimpure}

\newcommand{\pureint}{\tyint\atinyweebit\gray\typure}
\newcommand{\impureint}{\tyint\atinyweebit\gray\tyimpure}

\newcommand{\pureposix}{\typosix\atinyweebit\gray\typure}
\newcommand{\impureposix}{\typosix\atinyweebit\gray\tyimpure}
\textmath{\append}{{\mathtt{}{++}}}
\newcommand{\emspace}[1]{\mbox{\hspace{#1em}}}


\newcommand{\nil}{{\rm{[}}\atinyweebit{\rm{]}}}

%\newcommand{\expr}[1]{{\relax\ifmmode {{\bm{expr}}\,{{#1}}} \else {{\bf\em{#1}}\aweebit{{#1}}} \fi}}


\newsyntax{\integer}{{\it{int}}}
\newcommand{\fstring}{{\it{string}}}
\newcommand{\fchar}{{\it{char}}}
\newsyntax{\pubkey}{pubkey}
\newcommand{\tickstring}{{\textquotesingle{}address{}\textquotesingle}}
\newcommand{\bigvspace}{\ \vspace{.3em}\\}
\newcommand{\vbar}{{\relax\ifmmode {\,|\,} \else {$\,|\,$} \fi\relax}}

\newcommand{\close}{{\tt{close}}}

\newcommand{\barunion}{\cup\hspace{-.95em}+}

\textmath{\textmathin}{\in}

\textmath{\numeral}{{\mathit{N}}}
\textmath{\lowerId}{{\identifier_{{\mathit{L}}}}}
\textmath{\upperId}{\identifier_{{\mathit{U}}}}
\textmath{\nicerho}{\rho}
\newcommand{\Base}{\relax{\ifmmode{\theta}\else{$\theta$}\fi}}

% use \leading{1.1} to make the line a bit higher - good for adjusting captions on boxed figures.
\newcommand{\leading}[1]{\rule[{#1}pt]{0em}{1em}}
\newcommand{\adjustvertsp}{{\leading{1.2}}{\leading{-5.5}}}
\newcommand{\fixvert}{{\adjustversp}}




%\newcommand{\bits}{{{\em{Bit256}}}}
\newcommand{\bitscommand}{{\relax\ifmmode{{\squarewrap{\mathit{Bit256}}}}\else{{\squarewrap{\it{Bit256}}}}\fi}}

\newcommand{\extern}{\relax\ifmmode{\mathtt{extern}}\else{\tt{extern}}\fi}
\newcommand{\BinRel}{{\it{BinRel}}}
\newcommand{\IntOp}{{\it{IntOp}}}
\newcommand{\BoolOp}{{\it{BoolOp}}}
\newcommand{\optionalSemi}{\pairwrap{\tt{;}}} 


\newcommand{\optionalParam}{\pairwrap{(\parameter\kleenestar)}}
\newcommand{\optionalArgs}{\pairwrap{(\argument\kleenestar)}}
\newcommand{\Value}{\it{Value}}
\newcommand{\context}{\relax{\ifmmode {\Gamma} \else {$\Gamma$} \fi\relax}}
\newcommand{\Context}{\relax{\ifmmode {\mathit{Context}} \else {\it{Context}} \fi\relax}}

\newcommand{\ostar}{\ding{91}}

\newcounter{flinenumber}[figure]
\setcounter{flinenumber}{0}
\newcommand{\numit}{{\noindent\textcolor{gray}{{\refstepcounter{flinenumber}{\it{\theflinenumber.\abit}}}}}}

\newcommand{\numitStr}[1]{{\noindent\textcolor{gray}{#1}\abit}}
\newcommand{\situatedNumit}[2]{{\hspace{#1em}}\noindent\textcolor{gray}{{\refstepcounter{flinenumber}\theflinenumber.{\hspace{#2em}}}}}
\newcommand{\resetNumit}{\setcounter{flinenumber}{0}}
\newcommand{\setNumit}[1]{\setcounter{flinenumber}{#1}}


\newcommand{\MORE}{\red{More discussion needed here.}}
\newcommand{\needto}[1]{{\textcolor{red}{{#1}}}}

% We can change the following if we decide to refer to Isabelle instead of Haskell.
\newcommand{\Haskell}{Haskell}
\newcommand{\implementationLanguage}{\Haskell}



\textmath{\definedAs}{\stackrel{def}{=}}
\textmath{\Integer}{{\mathbb{Z}}}
\textmath{\Int}{Int}
\textmath{\Loc}{Loc}
\textmath{\Bool}{{\mathbb{B}}}
\textmath{\Posix}{\mathit{POSIXTime}}


\textmath{\paramStar}{{\parameter^{\star}}}
\textmath{\paramList}{\parenwrap{\paramStar}}
\textmath{\argList}{\parenwrap{\argument^{\star}}}


%{\scalerel*{.}{.001pt}}
\newenvironment{bogustabbing}{\begin{tabbing}\=\hspace{2em}\=\=\=\kill\hfill}%
{\end{tabbing}}

% program is indented 2em
\newenvironment{program}{\tt\obeyspaces\begin{bogustabbing}\+\kill}{\end{bogustabbing}}
\newenvironment{program*}{\small\tt\obeyspaces\begin{bogustabbing}\vspace{-.125in}}
{\vspace{-.125in}\end{bogustabbing}}

\newenvironment{program**}{\par \noindent \it \obeyspaces \begin{bogustabbing}}{\end{bogustabbing} \par \noindent}

\newenvironment{italics*}{\it\obeyspaces\noindent}{\rm}

%\newcommand\labelInFig[1][]{\label{\theflinenumber} }




% \newcommand{\labelfigureline}[1]{
%     \renewcommand\theflinenumber{\arabic{flinenumber}}
%     \addtocounter{flinenumber}{-1}
%     \refstepcounter{flinenumber}
%     \label{#1}   \renewcommand\theflinenumber{\theflinenumber.\arabic{flinenumber}}
% }

% \newcommand{\numitNamed}[1]{{\noindent\textcolor{gray}{{\refstepcounter{flinenumber}\theflinenumber.\abit}}}}



% \newcommand{\labelsubseccounter}[1]{
%     \renewcommand\thesubsection{\arabic{subsection}}
%     \addtocounter{subsection}{-1}
%     \refstepcounter{subsection}
%     \label{#1}
%     \renewcommand\thesubsection{\thesection.\arabic{subsection}}
% }


\newenvironment{slogan}{\par\medskip
   \noindent \textbf{Slogan:}~ \it}{\rm\medskip\\}

\setcounter{secnumdepth}{3}

\newcounter{sectionctr}[subsection]
\setcounter{sectionctr}{1}

% \newcounter{slogan}[subsection]
% \setcounter{slogan}{1}
% \newenvironment{slogan}[1][]{\par\medskip
%    \goodbreak\noindent \index{slogans!{#1}}
% {\bf%\thesubsection.\thesectionctr~
% {\em{Slogan}}}:%   \em{#1}}
% \it \relax}{ \medskip \par }   

% \newcounter{principle}[subsection]
% \setcounter{principle}{1}
\newenvironment{principle}[1][]{\refstepcounter{sectionctr}\medskip
   \noindent \index{principles!#1}\bf{~\thesection.\thesectionctr}~\textbf{\em{#1~Principle:}} \label{principle:#1}\par\it}{\medskip\par}


\newenvironment{comment}
  {\par\medskip
   \begin{framed}
   \begingroup\color{red}%
   \textbf{Comment: }\ignorespaces}
 {\endgroup\end{framed}
  \medskip}
  
\newenvironment{Remark}[1][]{\refstepcounter{sectionctr}\par\medskip
   \noindent \index{remark!#1}\bf{~\thesection.\thesectionctr}~\textbf{\em{#1~Remark:}} \label{remark:#1} \rm\relax }{ \medskip \par}

% \newcounter{Remark}[subsection]
% \setcounter{Remark}{1}
% \newenvironment{Remark}[1][]{\refstepcounter{sectionctr}\par\medskip
%    \noindent \textbf\thesubsubsection.\thesectionctr~\textem{#1~Remark:}}{ \medskip\par}


\newenvironment{Incomplete}[1][]{\refstepcounter{subsection}\par\medskip   \noindent\color{red}{~\thesubsubsection}~{\textbf\em{INCOMPLETE:}}}{ \medskip\par\rm}

\newcommand{\listwrap}[1]{{\texttt{[}} #1 \texttt{]}}



\newcommand{\syntaxtitle}[1]{{\multicolumn{3}{l}\thrice\abit\underline{\elbow{\elbow{\it{#1}}}}}}

%\newtheorem{Remark}{Remark}[section]

% \newtheorem{slogan}{Slogan}[section]

\newtheorem{theorem}{Theorem}

\newtheorem{ToDo}{{\red{ToDo}}}[subsection]



\newcommand{\mktypeRuleNum}[2]{\numit{{\begin{tabular}[c]{l}{\it{{#1}}}{}\\\hline{\leading{1.1}\it{{#2}}}\end{tabular}}}}


\newcommand{\mktypeRule}[2]{{{\begin{tabular}[b]{l}{\it{{#1}}}{}\\\hline{\leading{1.1}\it{{#2}}}\end{tabular}}}}


\newcommand{\mktypeRuleWNum}[3]{\numit{{\begin{tabular}[c]{l}
{\it{{#1}}}\\
\hline{\leading{1.1}\it{#2}}\\[.25ex]
\begin{tabular}{ll}
{\abit{}where {{#3}}}
\end{tabular}
\end{tabular}}}}


\newcommand{\mktypeRuleW}[3]{{\begin{tabular}[c]{l}
{\it{{#1}}}\\
\hline{\leading{1.1}\it{#2}}\\[.25ex]
\begin{tabular}{ll}
{\abit{}where {{#3}}}
\end{tabular}
\end{tabular}}}


\newcommand{\mktypeRuleNNum}[3]{\numit{{\begin{tabular}[b]{c}{\it{#1}}{}\\\hline{\it{\leading{1.1}#2}}\end{tabular}}\raisebox{2.2ex}{\aweebit\it{#3}}}}


\newcommand{\mktypeRuleN}[3]{{{\begin{tabular}[b]{c}{\it{#1}}{}\\\hline{\it{\leading{1.1}#2}}\end{tabular}}\raisebox{1.5ex}{\aweebit\it{#3}}}\raisebox{-1}

\textmath{\fromJust}{{\mathit{fromJust}}}
\textmath{\typesOf}{\text{\it{ty}}\atinyweebit}
\textmath{\varspec}{\mathit{vars\,}}